#include "itkNDLoop4.h"
#include <iostream>
#include <vector>


using namespace std;


/************************************
 *
 *    This is the Index class
 *
 ************************************/

typedef vector<unsigned int > myIndexType;



/************************************
 *
 *    This is the functor class
 *
 ************************************/

class printIndex  
{
  typedef myIndexType Index;
public:
  static void Run( const myIndexType & index ) 
  {
    
    myIndexType::const_iterator ind = index.begin();
    while ( ind != index.end() ) 
    {
      cout << *ind << " ";
      ind++;
    }
    cout << endl;
  }
};



/************************************
 *
 *    Example of how to use it
 *
 ************************************/

int main() 
{
  
  myIndexType begin;
  myIndexType end;

  begin.push_back(0);
  begin.push_back(0);
  begin.push_back(0);
  begin.push_back(0);

  end.push_back(3);
  end.push_back(3);
  end.push_back(3);
  end.push_back(2);
  
  Do< printIndex >::ForEachInRegion ( begin , end );

  return 0;
}


